<%
response.setHeader( "Cross-Origin-Opener-Policy", "same-origin" );
response.setHeader( "Cross-Origin-Embedder-Policy", "require-corp" );
%>                                    




<!doctype html><html lang="en-us">
<head>
	<meta charset="utf-8">
	<style>
		* { margin:0; padding:0; } /* to remove the top and left whitespace */
		html, body { width:100%; height:100%; background-color:black} /* just to be sure these are full screen*/
		canvas { display:block; } /* To remove the scrollbars */
	</style>
	<link rel="icon" type="image/x-icon" href="favicon.ico">
</head>

<script async type="text/javascript" src="dhviewer.js"></script>
<!--script>

var Module={};

function binary(e){
	return new Promise( ((n,r)=>{
		var a=new XMLHttpRequest;
		a.open("GET",e,!0),
		a.responseType="arraybuffer",
		a.onload=()=>{
			n(a.response)
		},
		a.send(null)
	}) )
}

function script(e){
	return new Promise( ((n,r)=>{
		var a=document.createElement("script");
		a.src=e,
		a.onload=()=>{
			n()
		},
		document.body.appendChild(a)
	}) )
}

</script--->

<script>


function loadPBS() {

	console.log("loadPBS");
	const queryString = window.location.search;
	console.log(queryString);
	const urlParams = new URLSearchParams(queryString);	
	var _study = urlParams.get('study');
	if ( !_study )
		_study="";
	console.log("study: " + _study);
	var _context = urlParams.get('cViewerContextId');
	if ( !_context )
		_context = "";
	console.log("context: " + _context);
	const _user = urlParams.get('cUser');
	console.log("user: " + _user);
	const _session = urlParams.get('authToken');
	console.log("session: " + _session);


	const pbsurl = window.location.protocol + "//" + window.location.hostname + "/iface/getpbs.jsp?";

	var strRequest = pbsurl;
	var notfirst = false;
	if ( _study && (! _study==="") ) {
		if (notfirst) {
			strRequest += "&";
		} else {
			notfirst = true;
		}
		strRequest += "SYUI=" + encodeURI(_study);
	}
	if ( _context && (!_context=="") ) {
		if (notfirst) {
			strRequest += "&";
		} else {
			notfirst = true;
		}
		strRequest += "VCID=" + encodeURI(_context);
	}

	var xhr = new XMLHttpRequest();
	xhr.open("GET", strRequest);
	xhr.onload = function () {
		if (this.status === 200) {
			var pbs = this.responseText;
			var pbs_length = pbs.length;
			console.log(pbs);
			Module._init_session( stringToNewUTF8(pbs) );
		}
	};
	xhr.send();

};

var have_profile = 0;

function loadProfile() {

	console.log("loadProfile");

	const pbsurl = window.location.protocol + "//" + window.location.hostname + "/cases/viewer/getuserconfig.jsp";
	var strRequest = pbsurl;

	var xhr = new XMLHttpRequest();
	xhr.open("GET", strRequest);
	xhr.onload = function () {
		if (this.status === 200) {
			var profile = this.responseText;
			var profile_length = profile.length;
			have_profile = 1;
			Module._init_userprofile( stringToNewUTF8(profile) );
		}
	};
	xhr.send();
};	

//var Module={};

function drawFrame() {
	Module._refresh_webgl();
	requestAnimationFrame( drawFrame);
}


function init() {
	canvas = document.getElementById('canvas');
	canvas.addEventListener( 'mousedown', function(event) {
		event.preventDefault();
		Module._OnMouseDown_webgl( event.button, event.buttons, event.offsetX * window.devicePixelRatio, event.offsetY * window.devicePixelRatio);
		}, true);
	canvas.addEventListener( 'mouseup', function(event) {
		event.preventDefault();
		Module._OnMouseUp_webgl( event.button, event.buttons, event.offsetX * window.devicePixelRatio, event.offsetY * window.devicePixelRatio);
        }, true);
	canvas.addEventListener( 'mousemove', function(event) {
		event.preventDefault();
		//console.log("mousemove " + event.offsetX + "," + event.offsetY);
		Module._OnMouseMove_webgl( event.offsetX * window.devicePixelRatio, event.offsetY * window.devicePixelRatio);
        }, true);
	canvas.addEventListener( 'wheel', function(event) {
		event.preventDefault();
		//console.log("mousemove " + event.offsetX + "," + event.offsetY);
		Module._OnMouseWheel_webgl( 0, event.deltaY, event.offsetX * window.devicePixelRatio, event.offsetY * window.devicePixelRatio);
        }, true);
	//document.addEventListener('keydown', function(event) {
	//	event.preventDefault();
	//	console.log('keydown code: ' + event.code + ' key: ' + event.key);
	//	Module._OnKeyDown_webgl(stringToNewUTF8(event.code));
	//	}, true);
	//document.addEventListener('keyup', function(event) {
	//	event.preventDefault();
	//	console.log('keyup code: ' + event.code + ' key: ' + event.key);
	//	Module._OnKeyUp_webgl(stringToNewUTF8(event.code));
	//	}, true);
	window.addEventListener('resize', function(event) {
		resizeCanvas();
		}, true);
	canvas.addEventListener("contextmenu", function(event){
		event.preventDefault();
		}, true);
	document.body.style.overflow = 'hidden';

	//if ( !_study )
	//	_study="";
	//if ( !_context )
	//	_context = "";
	//	
	//var ptr1  = stringToNewUTF8(_study);	
	//var ptr2  = stringToNewUTF8(_session);	
	//var ptr3  = stringToNewUTF8(_context);	
	//var ptr4  = stringToNewUTF8(_user);	
	//Module._init_params(ptr1,ptr2,ptr3,ptr4);	
		
	Module._init_webgl(1,1);
	resizeCanvas();
	
	requestAnimationFrame( drawFrame);
	
	setTimeout( "loadProfile()", 10);
	setTimeout( "loadPBS()", 100);
}


function draw() {
	Module._refresh_webgl( 0);
}

function forceDraw() {
	Module._refresh_webgl( 1);
}

function imageReady( texName)
{
	Module._refresh_texture( stringToNewUTF8( texName));
}


function resizeCanvas() {
	canvas = document.getElementById('canvas');
	console.log("SetSize " + window.innerWidth + "," + window.innerHeight + "," + window.devicePixelRatio);
	canvas.width = window.innerWidth * window.devicePixelRatio - 8;
	canvas.height = window.innerHeight * window.devicePixelRatio - 8;
	Module._OnResize_webgl( canvas.width, canvas.height);
}

var Module = {
  onRuntimeInitialized: function() {
    init();
  }
};

//Module.onRuntimeInitialized = () => { init(); };


//
//Promise.all( [ binary("dhviewer.js"), binary("dhviewer.wasm") ] ).then(
//	(e=>{
//		Module.wasm=e[1];
//		var n=URL.createObjectURL(new Blob([e[0]],{type:"application/javascript"}));
//		script(n).then( (()=>{
//			URL.revokeObjectURL(n)
//		}) ) 
//	}) 
//);
//

function showDialog() {
	var dialog = document.getElementById('myModalDialog');
	dialog.showModal();
}

function closeDialog() {
	var dialog = document.getElementById('myModalDialog');
	dialog.close();
}



</script>



<body>
<dialog id="myModalDialog" style="display:none;"></dialog>
<!--<button onclick="init()">init</button>
<button onclick="loadPBS()">open</button>  -->

<canvas id='canvas' style='display:block; margin:auto;' tabindex=1 ></canvas>

</br>
</body>

</html>
